// DlgUpgradeHttp.cpp : ʵļ
//

#include "stdafx.h"
#include "EHomeDemo.h"
#include "DlgUpgradeHttp.h"
#include "afxdialogex.h"
#include "public/cjson/cJson.h"

#define CYCLE_GETPROGRESS_TIMER        1        //get progress timer

// CDlgUpgradeHttp Ի

IMPLEMENT_DYNAMIC(CDlgUpgradeHttp, CDialogEx)

CDlgUpgradeHttp::CDlgUpgradeHttp(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDlgUpgradeHttp::IDD, pParent)
    , m_csPassword(_T(""))
    , m_dwPort(0)
    , m_csFileName(_T(""))
    , m_sOutput(_T(""))
{
    m_lLoginID = -1;
    m_iDeviceIndex = -1;
}

CDlgUpgradeHttp::~CDlgUpgradeHttp()
{
}

void CDlgUpgradeHttp::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_EDIT_PASSWORD, m_csPassword);
    DDX_Text(pDX, IDC_EDIT_PORT, m_dwPort);
    DDX_Text(pDX, IDC_EDIT_UPGRADE_FILENAME, m_csFileName);
    DDX_Control(pDX, IDC_UPGRADE_SERVER_IP, m_IPServer);
    DDX_Text(pDX, IDC_EDIT_OUTPUT, m_sOutput);
}


BEGIN_MESSAGE_MAP(CDlgUpgradeHttp, CDialogEx)
    ON_BN_CLICKED(IDOK, &CDlgUpgradeHttp::OnBnClickedOk)
    ON_WM_TIMER()
    ON_WM_CLOSE()
    ON_BN_CLICKED(IDC_BTN_STOP_UPGRADE, &CDlgUpgradeHttp::OnBnClickedBtnStopUpgrade)
END_MESSAGE_MAP()


// CDlgUpgradeHttp Ϣ


void CDlgUpgradeHttp::OnBnClickedOk()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    DWORD dwIP = 0;
    char sServerIP[16] = { 0 };
    m_IPServer.GetAddress(dwIP);
    memcpy(sServerIP, IPToStr(dwIP), 16);

    CString m_strInputXml;
    m_strInputXml.Format("{\r\n  \"serverIP\": \"%s\",\r\n"\
        "  \"serverPort\": %u,\r\n"\
        "  \"fileUrl\": \"%s\"\r\n}"\
         , sServerIP, m_dwPort, m_csFileName);

    NET_CMS_ISAPI_CONFIG struISAPIXML = { 0 };
    struISAPIXML.dwSize = sizeof(NET_CMS_ISAPI_CONFIG);

    char szCmd[129] = { 0 };
    DWORD dwCmdLen = 0;
    strcpy(szCmd, "POST ISAPI/System/update/EHome/StartUpdate?format=json");
    char szInBuffer[1500] = { 0 };
    strcpy(szInBuffer, m_strInputXml);
    struISAPIXML.lpInBuffer = szInBuffer;
    struISAPIXML.dwInBufferSize = sizeof(szInBuffer);
    struISAPIXML.dwRecvTimeOut = 5 * 1000;

    struISAPIXML.lpRequestUrl = szCmd;
    struISAPIXML.dwRequestUrlLen = strlen(szCmd);


    char szOutBuffer[1500] = { 0 };
    struISAPIXML.lpOutBuffer = szOutBuffer;
    struISAPIXML.dwOutBufferSize = sizeof(szOutBuffer);

    if (NET_ECMS_ISAPI_Config(m_lLoginID, &struISAPIXML))
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, 1, "NET_ECMS_ISAPI_Config");
        //MessageBox("Start upgrade successful");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, 1, "NET_ECMS_ISAPI_Config");
        MessageBox("Start upgrade false");
        //return;
    }

    m_sOutput = szOutBuffer;

    int pCycleTimer = SetTimer(CYCLE_GETPROGRESS_TIMER, 200, NULL);

    UpdateData(FALSE);
}

void CDlgUpgradeHttp::GetProgress()
{
    UpdateData(TRUE);

    NET_CMS_ISAPI_CONFIG struISAPIXML = { 0 };
    struISAPIXML.dwSize = sizeof(NET_CMS_ISAPI_CONFIG);

    char szCmd[129] = { 0 };
    DWORD dwCmdLen = 0;
    strcpy(szCmd, "GET ISAPI/System/update/EHome/UpgradeStatus?format=json");

    struISAPIXML.dwRecvTimeOut = 5 * 1000;

    struISAPIXML.lpRequestUrl = szCmd;
    struISAPIXML.dwRequestUrlLen = strlen(szCmd);

    char szOutBuffer[1500] = { 0 };
    struISAPIXML.lpOutBuffer = szOutBuffer;
    struISAPIXML.dwOutBufferSize = sizeof(szOutBuffer);

    if (NET_ECMS_ISAPI_Config(m_lLoginID, &struISAPIXML))
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, 1, "NET_ECMS_ISAPI_Config");
       // MessageBox("Start upgrade successful");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, 1, "NET_ECMS_ISAPI_Config");
        //MessageBox("Start upgrade false");
        return;
    }

    int iPercent = 0;

    m_sOutput = szOutBuffer;
    cJSON* pRoot = cJSON_Parse(szOutBuffer);
    if (pRoot == NULL)
    {
        return;
    }

    cJSON* pPercent = cJSON_GetObjectItem(pRoot, "percent");
    if (pPercent == NULL || pPercent->type != cJSON_Number)
    {
        return ;
    }

    iPercent = pPercent->valueint;

    CString csPercent;
    csPercent.Format("%d%%", iPercent);
    GetDlgItem(IDC_STATIC_PROGRESS)->SetWindowText(csPercent);
    CProgressCtrl *pProgCtrl = (CProgressCtrl*)GetDlgItem(IDC_PROG_UPGRADE);
    pProgCtrl->SetPos(iPercent);

    if (iPercent >= 100)
    {
        KillTimer(CYCLE_GETPROGRESS_TIMER);
    }

    UpdateData(FALSE);
}


BOOL CDlgUpgradeHttp::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    // TODO:  ڴӶĳʼ
    CProgressCtrl *pProgCtrl = (CProgressCtrl*)GetDlgItem(IDC_PROG_UPGRADE);
    pProgCtrl->SetPos(0);
    pProgCtrl->SetRange(0, 100);//ýΧ

    char szLan[1024] = { 0 };
    m_iDeviceIndex = g_pMainDlg->GetCurDeviceIndex();
    if (m_iDeviceIndex < 0)
    {
        g_StringLanType(szLan, "ѡһ豸!", "please select a device first!");
        g_pMainDlg->AddLog(-1, OPERATION_FAIL_T, 0, szLan);
        return FALSE;
    }
    m_lLoginID = g_struDeviceInfo[m_iDeviceIndex].lLoginID;
    if (m_lLoginID < 0)
    {
        g_StringLanType(szLan, "豸δע!", "device offline!");
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, 0, szLan);
        return FALSE;
    }

    return TRUE;  // return TRUE unless you set the focus to a control
    // 쳣:  OCX ҳӦ FALSE
}


void CDlgUpgradeHttp::OnTimer(UINT_PTR nIDEvent)
{
    // TODO:  ڴϢ/Ĭֵ
    switch (nIDEvent)
    {
    case CYCLE_GETPROGRESS_TIMER:
        GetProgress();
        break;
    default:
        break;
    }
    CDialogEx::OnTimer(nIDEvent);
}


void CDlgUpgradeHttp::OnClose()
{
    // TODO:  ڴϢ/Ĭֵ
    KillTimer(CYCLE_GETPROGRESS_TIMER);
    CDialogEx::OnClose();
}


void CDlgUpgradeHttp::OnBnClickedBtnStopUpgrade()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    NET_CMS_ISAPI_CONFIG struISAPIXML = { 0 };
    struISAPIXML.dwSize = sizeof(NET_CMS_ISAPI_CONFIG);

    char szCmd[129] = { 0 };
    DWORD dwCmdLen = 0;
    strcpy(szCmd, "POST ISAPI/System/update/EHome/stopUpdate?format=json");

    struISAPIXML.dwRecvTimeOut = 5 * 1000;

    struISAPIXML.lpRequestUrl = szCmd;
    struISAPIXML.dwRequestUrlLen = strlen(szCmd);

    char szOutBuffer[1500] = { 0 };
    struISAPIXML.lpOutBuffer = szOutBuffer;
    struISAPIXML.dwRequestUrlLen = sizeof(szOutBuffer);

    if (NET_ECMS_ISAPI_Config(m_lLoginID, &struISAPIXML))
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, 1, "NET_ECMS_ISAPI_Config");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, 1, "NET_ECMS_ISAPI_Config");
        MessageBox("Stop upgrade false");
        return;
    }

    m_sOutput = szOutBuffer;
    UpdateData(FALSE);
    return;
}
